float4      FogColor;
float4x4    mViewProj : WORLDVIEWPROJ;

texture BaseTexture;
texture DetailTexture;
texture DetailTexture2;
//texture DetailTexture3;

sampler Base = 
sampler_state
{
    Texture = <BaseTexture>;
    MipFilter = LINEAR;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
};

sampler Detail = 
sampler_state
{
    Texture = <DetailTexture>;
    MipFilter = LINEAR;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
};
/* */
sampler Detail2 = 
sampler_state
{
    Texture = <DetailTexture2>;
    MipFilter = LINEAR;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
};
/*
sampler Detail3 = 
sampler_state
{
    Texture = <DetailTexture3>;
    MipFilter = LINEAR;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
};/**/
struct VS_INPUT
{
    float4  Pos             : POSITION;
    float4  Diffuse         : COLOR0;
    float2  Tex0            : TEXCOORD0;
};

struct VS_OUTPUT
{
    float4  Pos     : POSITION;
    float4  Diffuse : COLOR0;
    //float   Specular : COLOR1;
    float2  Tex0    : TEXCOORD0;
    float2  Tex1    : TEXCOORD1;
    float2  Tex2    : TEXCOORD2;
    //float2  Tex3    : TEXCOORD3;
};

VS_OUTPUT SceneVS(VS_INPUT i)
{
    VS_OUTPUT   o;
    o.Pos = mul(float4(i.Pos.xyz,1), mViewProj);
    o.Diffuse = i.Diffuse;
	o.Tex0 = i.Tex0;
	o.Tex1 = i.Tex0 * 512.0f;
	o.Tex2 = i.Tex0 * 64.0f;
	o.Diffuse.a = o.Pos.z * 0.003;
	//if (i.Pos.y < 8.0f) o.Diffuse.a +=  (8 - i.Pos.y) / 2.0f;
	//if (i.Pos.y < 2.0f) o.Diffuse.a +=  (2 - i.Pos.y) * 2.0f;
	if (i.Pos.y < 13.0f) o.Diffuse.a +=  (13 - i.Pos.y) * 0.2f;
    return o;
}

struct PS_OUTPUT
{
    float4 RGBColor : COLOR0; 
};

PS_OUTPUT ScenePS( VS_OUTPUT In) 
{ 
    PS_OUTPUT Output;
    /*
    float4 BaseMap   = tex2D(Base,   In.Tex0);
    float  DetailMap = dot(In.Diffuse, tex2D(Detail, In.Tex1));
    float4 TerrainColor = (BaseMap * DetailMap) * 4;
    Output.RGBColor = lerp(TerrainColor, FogColor, In.Diffuse.b);
    */
    
    /* */ 
    float4 BaseMap   = tex2D(Base,   In.Tex0);
    float4 RockColor = tex2D(Detail2, In.Tex2);
    float  DetailMap = dot(In.Diffuse, tex2D(Detail, In.Tex1));
    float4 TerrainColor = (BaseMap * DetailMap);
    float4 BlendColor = lerp(TerrainColor, RockColor, In.Diffuse.b) * BaseMap.w;
    Output.RGBColor = lerp(BlendColor, FogColor, In.Diffuse.a) + 0.015f; /* */
        
    //float4 B = tex2D(Detail2,   In.Tex0);
    //Output.RGBColor = In.Diffuse;
    return Output;
}

technique t0
{
    pass p0
    {
         VertexShader = compile vs_1_1 SceneVS();
         PixelShader  = compile ps_1_1 ScenePS();
    }
}

